<p align=center>
    <picture>
        <source
            srcset="https://raw.githubusercontent.com/honey-team/ufpy/main/readme_assets/logo_d.svg"
            media="(prefers-color-scheme: dark), (min-width: 200px)"
        />
        <source
            srcset="https://raw.githubusercontent.com/honey-team/ufpy/main/readme_assets/logo_l.svg"
            media="(prefers-color-scheme: light), (prefers-color-scheme: no-preference), (min-width: 200px)"
        />
        <img src="https://raw.githubusercontent.com/honey-team/ufpy/main/readme_assets/logo.svg" width="200" alt="Logo" style="text-align: center" />
    </picture>
</p>

<p align=center>
    <a href="https://pypi.org/project/ufpy">
        <img src="https://img.shields.io/pypi/v/ufpy?style=flat&logo=pypi&logoColor=white&label&color=blue" alt="Pypi">
    </a>
    <a href="https://python.org">
        <img src="https://img.shields.io/badge/3.12%2B-blue?logo=python&logoColor=white" alt="Python version">
    </a>
    <a href="https://honey-team.ru/ufpy-website">
        <img src="https://img.shields.io/badge/docs-blue?logo=material%20for%20mkdocs&logoColor=white" alt="Docs">
    </a>
    <a href="https://pypi.org/project/pylint">
        <img src="https://img.shields.io/badge/pylint-blue" alt="Pylint">
    </a>
    <a href="https://pypi.org/project/black">
        <img src="https://img.shields.io/badge/black-blue" alt="Black">
    </a>
</p>

Ufpy (Useful Python) - package for Python with some useful features which can help you!

# Key features

- Useful dict (UDict) for simplification working with dictionaries. [See more...](examples/udict.md)
- Download GitHub's public repositories, its folders and files. [See more...](examples/github/download.md)
- Some type alias and protocols
- And more!

# Installation

## Install latest version

To install `ufpy` with `pip` use this command in your shell
```sh
pip install ufpy
```

## Install specific version

To install specific version of `ufpy` with `pip` use this command in your shell
```sh
# Example: install ufpy 0.2
pip install ufpy==0.2
```

## Install dev version

To install dev version with `pip` use this command in your shell
```sh
pip install git+https://github.com/honey-team/ufpy.git
```

# Contributing

You can contribute to this project via [GitHub](https://github.com/honey-team/ufpy). Here's how:
1. Fork the repository
2. Create a new branch for your feature or bug fix
3. Make your changes, following our [coding standards](/CONTRIBUTING.md/)
4. Write tests for your changes
5. Ensure all tests pass
6. Submit a pull request with a clear description of your changes
For more detailed guidelines, please see our [Contributing Guide](/CONTRIBUTING.md).

If you want to contribute to docs website, fork [website repository](https://github.com/honey-team/ufpy-website) and open pull request!

# Support

If you have a problem or just have a question, open [discussion in GitHub](https://github.com/honey-team/ufpy/discussions). Also you can tell me your suggestions and ideas in this [discussions](https://github.com/honey-team/ufpy/discussions).

Enjoy `ufpy`! I'd like to see that my project will be using in your projects. Bye! :)
